<template>
  <div>
    <!-- left -->
    <div id="main-window">
      <highcharts id="container" class="stock" :constructor-type="'stockChart'" :options="stockOptions"></highcharts>
    </div>
    
    <!-- right -->
    <div id="sidebar">

      <p v-if="isSaved" class="danger" style="padding: 10px">Session successfully saved!</p>

      <!-- select Dataset -->
      <p>Select Dataset</p>
      <select style="width:300px;" @change="loadDataset()" v-model="selectedDataset">
        <option v-for="option in datasetOptions" :value="option">Dataset {{ option + 1 }}</option>
      </select>

      <div v-if="!allRanges.length && !loadedRanges.length">
        <h2>Select Data Range</h2>
      </div>

      <div v-if="allRanges.length" style="margin: 0px auto; width: 100%;">
        <div class="selected-range-container">
          <div v-for="(range, index) in allRanges">

            <div class="selected-range" style="display: flow-root;">

              <p>{{ range.start.date | formatDate }} - {{ range.end.date | formatDate }}</p>
              <p>Pattern Type</p>
                <select @change="selectPattern(index)" v-model="range.pattern">
                  <option v-for="option in patterns" :value="option">Pattern {{ option }}</option>
                </select>

              <div style="float:right" class="button danger" @click="deleteRange(index)" type="button">Delete</div>
              <div style="clear:both"></div>
            </div>
            </div>
          </div>
        <div class="button info" style="margin: 5px" @click="submit() "type="button">Save Session</div>
      </div>

      <div v-if="loadedRanges.length && loadedRanges !== allRanges" style="margin: 0px auto; width: 100%;">
        <div class="button info" style="margin: 5px" @click="loadSession() "type="button">Load Session</div>
      </div>
    </div>
  </div>

</template>

<script>
import axios from 'axios'
import stock1 from '../data/stock_data1.json';
import stock2 from '../data/stock_data2.json';
import stock3 from '../data/stock_data3.json';


let parsedData = [];
let filtered = [stock1, stock2, stock3].filter(function (el) {
  return el.length > 0;
});


export default {
  created () {
    this.parseData(parsedData, stock1);
    this.loadData();
  },
  data () {
    let self = this;
    return {
      chart: null,
      datasetOptions: [...Array(filtered.length).keys()],
      datasets: filtered,
      selectedDataset: 0,
      isSaved: false,
      selectedPattern: '1',
      allRanges: [],
      loadedRanges: [],
      patterns: ['1', '2', '3'],
      keys: ['position', 'date', 'open', 'close', 'high', 'low'],
      stockOptions: {
        title: {
          text: 'Stock Price'
        },
        series: [{
          id: 'aapl',
          name: 'STOCK PRICE',
          type: 'candlestick',
          data: parsedData
        },
        {
          type: 'sma',
          linkedTo: 'aapl'
        }],
        chart: {
          renderTo: 'container',
          events: {
            load: function () {
               self.chart = this;
            },
            selection: function(event) {
              let chart = this;
              self.isSaved = false;
              // discard all but the necessary properties of the axis object
              // also helps with serialization
              let xAxis = {max: event.xAxis[0].max, min: event.xAxis[0].min};
              let yAxis = {max: event.yAxis[0].max, min: event.yAxis[0].min};
              let selectedRange = {
                rect: null,
                pattern: '1',
                selectedDataset: self.selectedDataset,
                xAxis: xAxis,
                yAxis: yAxis
              };

              // draw rectangle around selection
              let rect = self.drawRectangle(chart, xAxis, yAxis);
              selectedRange.rect = rect;

              for (var i = 0; i < chart.series[0].points.length; i++) {
                // use chart.series.points object, NOT chart.series.data
                // ref: https://stackoverflow.com/questions/28207881/highcharts-get-series-data-zoom-indices
                let point = chart.series[0].points[i];
                if (point.x > event.xAxis[0].min &&
                    point.x < event.xAxis[0].max &&
                    point.y > event.yAxis[0].min &&
                    point.y < event.yAxis[0].max) {
                      point.select(true, true);
                      // format datetime
                      let t = new Date(point.x);
                      let row = {
                        date:      t.toLocaleDateString("en-US") + ' ' + t.toLocaleTimeString("en-US"),
                        open:      point.plotOpen.toFixed(2), 
                        high:      point.plotHigh.toFixed(2), 
                        low:       point.plotLow.toFixed(2), 
                        close:     point.plotClose.toFixed(2)
                      }
                      selectedRange.hasOwnProperty('start') ? selectedRange.end = row : selectedRange.start = row;
                    }
              }
              self.allRanges.push(selectedRange);
              // sort chronologically by start.date
              self.allRanges.sort(self.compare);
              // automatically increment to the new length
              self.selectedIndex = self.allRanges.length;
              return false;
            },
            redraw: function () {
              self.isSaved = false;
              // sort
              self.allRanges.sort(self.compare);
              for(let range of self.allRanges) {
                self.deleteRectangles(range);
                range.rect = self.drawRectangle(self.chart, range.xAxis, range.yAxis);
              }
            },
          },
          zoomType: 'xy',
        },
        tooltip: {
          enabled: false
        },
      }
    }
  },
  methods: {
    reset: function () {
      for (let index of this.allRanges.keys()) {
        this.deleteRectangles(this.allRanges[index]);
      }
      this.allRanges = [];
    },
    parseData: function (array, stock) {
      for (var row of stock) {
        // format datetime
        let d = row.TIME.split('/');
        let newDateTime = new Date(d[1] + '/' + d[0] + '/' + '20' + d[2]);
        let t = new Date(newDateTime).getTime();
        let parsedRow = [t, row.OPEN, row.HIGH, row.LOW, row.CLOSE];
        array.push(parsedRow);
      }
      return array;
    },
    loadDataset: function () {
      this.reset();
      let chart = this.$children[0].chart;
      let index = this.selectedDataset;
      console.log('loadDataset', index);
      let parsedData = this.parseData([], this.datasets[index]);
      chart.series[0].setData(parsedData);
    },
    loadData: function () {
      let self = this;
      let loadedRanges;
      // use unique query parameter to avoid caching
      let uuid = new Date().getTime();
      let filePath = '../../dist/'+window.username+'-data.json?q='+uuid;
      // load saved json file, if exists
      axios.get(filePath)
      .then(function( data) {
        loadedRanges = JSON.parse(data.data).data;
        // assign saved data to allRanges
        self.loadedRanges = loadedRanges;
        // TODO: draw rectangles
        console.log('loaded data SUCCESS.', self.loadedRanges);
      })
      .catch(function (event, jqxhr, exception) {
        console.log('loaded data ERROR.');
      })
    },
    loadSession: function () {
      let index = this.loadedRanges[0].selectedDataset;
      this.selectedDataset = index;
      this.loadDataset();
      console.log('loadSession', this.allRanges);
      this.allRanges = this.loadedRanges.sort(self.compare);
      console.log('loadSession', this.allRanges);
      let chart = this.$children[0].chart;
      for (let range of this.allRanges) {
        range.rect = this.drawRectangle (chart, range.xAxis, range.yAxis);
      }
    },
    drawRectangle: function (chart, xAxis, yAxis) {
      let rectangle;
      let xMin = chart.xAxis[0].translate((xAxis||chart.xAxis[0]).min),
          xMax = chart.xAxis[0].translate((xAxis||chart.xAxis[0]).max),
          yMin = chart.yAxis[0].translate((yAxis||chart.yAxis[0]).min),
          yMax = chart.yAxis[0].translate((yAxis||chart.yAxis[0]).max);
      rectangle = chart.renderer.rect(0,0,0,0,0).css({
        stroke: 'white',
        strokeWidth: '.5',
        fill: '#666666',
        fillOpacity: '.5'
      }).add();
      rectangle.attr({
        x: xMin + chart.plotLeft,
        y: chart.plotHeight + chart.plotTop - yMax,
        width: xMax - xMin,
        height: yMax - yMin
      });
      return rectangle;
    },
    deleteRectangles: function (range) {
       let rect = range.rect;
       rect ? rect.destroy() : null;
    },
    deleteRange: function (index) {
      // remove selection rectangle
      this.deleteRectangles(this.allRanges[index]);
      this.allRanges.splice(index, 1);
      this.selectedIndex = index;
    },
    compare: function (a, b) {
      let startDateA = (typeof a.start.date === "string") ? Date.parse(a.start.date) : a.start.date;
      let startDateB = (typeof b.start.date === "string") ? Date.parse(b.start.date) : b.start.date;
      if (startDateA < startDateB)
        return -1;
      if (startDateA > startDateB)
        return 1;
      return 0;
    },
    selectPattern: function (index) {
      this.allRanges[index].start.pattern = this.selectedPattern;
      this.allRanges[index].end.pattern = this.selectedPattern;
    },
    submit: function () {
      let self = this;
      let url = '/save';
      let rects = [];
      for (var range of self.allRanges) {
        // keep array of rects so can be added back after save
        rects.push(range.rect);
        // can't convert this to JSON
        range.rect = null;
      }
      axios.post(url, {
        data: self.allRanges,
        headers: {
          'content-type': 'application/json',
        },
      }) 
      .then(function (response) {
        self.isSaved = true;
        let index = 0;
        // re-add rects
        for (var range of self.allRanges) {
            range.rect = rects[index];
            index ++;
        }
        console.log('saved data:', [response, self.isSaved]);
      })
      .catch(function (error) {
        console.log('error', error);
      })
    }
  },
  filters: {
    capitalize: function (str) {
      return str.charAt(0).toUpperCase() + str.slice(1)
    },
    formatDate: function (input) {
      let parts = input.split('/');
      let year_time = parts[2];
      let day = parts[1];
      let month = parts[0];
      return day+'/'+month+'/'+year_time;
    },
  },
}
</script>
<style scoped>
.button {
  cursor: pointer;
  padding: 10px;
  width: auto;
}
.danger {
  background: red;
  color: white;
}
.info {
  background: blue;
  color: white;
}
.selected-range {
  background: rgba(102, 133, 194, 0.4);
  text-align: left;
  height: 170px;
  padding: 10px;
  margin: 5px;
}
li {
  display: block;
}
table {
  border: 2px solid #42b983;
  border-radius: 3px;
  background-color: #fff;
  font-size: 0.9em;
}

th {
  background-color: #42b983;
  color: white;
  cursor: pointer;
  -webkit-user-select: none;
  -moz-user-select: none;
  -ms-user-select: none;
  user-select: none;
}

td {
  background-color: #f9f9f9;
}

th, td {
  min-width: 80px;
  padding: 10px 20px;
}



/* tabs */
/* Sidenav */
.sidenav__tabs {
  text-align: left;

}
.sidenav__tab {
  padding: .6em .4em .6em .8em;
  color: #eee;
  letter-spacing: 0;
  transition: all 300ms;
  background-color: rgb(66, 185, 131, 0.5);
}
.sidenav__tab:hover {
  background-color: rgb(66, 185, 131, 1);
  cursor: pointer;
}
.sidenav__tab__info {
  font-size: .65em;
  margin-top: 3px;
  color: #ccc;
  font-style: italic;
  letter-spacing: 0;
}
.active-tab {
  background-color: rgb(66, 185, 131, 1);
}
/* End Sidenav */

</style>
